#!/usr/bin/wish -f
wm title . "tKwhois"
source tkwhois.rc
frame .winMain -width 550 -height 250 -bg #c0c0c0 -relief raised -borderwidth 2 
pack .winMain -side top -fill both -expand true
#.^. Creates the frame which holds the other widgets

frame .winMain.top -width 544 -height 100 -bg #c0c0c0
frame .winMain.bottom -width 548 -height 146 -bg #c0c0c0 -relief flat -borderwidth 1

pack .winMain.top -anchor s -fill x -padx 1m -pady 1m
pack .winMain.bottom -anchor center -fill both -expand true  -padx 1m -pady 1m
#.^. Create 2 sub frames and diplay them on the screen
#.^. The top frame is the control panel
#.^. The bottom frame is for displaying any data from our queries

frame .winMain.top.left -width 290 -height 96 -bg #c0c0c0 -relief flat -borderwidth 1
frame .winMain.top.right -width 250 -height 96 -bg #c0c0c0 -relief sunken

pack .winMain.top.left -side left -fill x -expand true
pack .winMain.top.right -side right
#.^. Draw the top left and top right frames


     listbox .winMain.top.left.srvList -bg #b3b6ac -width 35 -height 5 -relief flat -font "courier $listFontSize normal" -yscrollcommand ".winMain.top.left.c set"
     pack .winMain.top.left.srvList -side left -fill x -expand true
     scrollbar .winMain.top.left.c -command ".winMain.top.left.srvList yview"
     pack .winMain.top.left.c -side right -fill y

#.^. Create a list box in the LHS frame

     set file0 [open whoisSrv.txt]
     while {[gets $file0 line] >= 0} {
     	.winMain.top.left.srvList insert end [lrange $line 0 2]
     }
     close $file0
#.^. This reads the contents of the listbox from a file

     bind .winMain.top.left.srvList <Double-Button-1> {
          clearScr
          set j [selection get]
          puts $j
          set k [lrange $j 2 2]
          set whoisServerName [lrange $j 2 2]
          set domainName {}
     }
#.^. Bind double click to select server


entry .winMain.top.right.domain -bg bisque3 -width 20 -textvariable domainName
entry .winMain.top.right.srvNam -bg bisque3 -width 20 -textvariable whoisServerName

label .winMain.top.right.domaintxt  -bg #c0c0c0 -width 12 -text {Domain :} -font "courier $labelFontSize normal"
label .winMain.top.right.serverName -bg #c0c0c0 -width 12 -text {Server :} -font "courier $labelFontSize normal"

button .winMain.top.right.help -bg bisque3 -text {Help} -font "courier $buttonFontSize normal" -relief groove -cursor question_arrow -command showHelp
button .winMain.top.right.about -bg bisque3 -text {About} -font "courier $buttonFontSize normal" -relief groove -cursor icon -command aboutThis

button .winMain.top.right.query -bg bisque3 -text {Start} -font "courier $buttonFontSize normal" -relief groove -cursor shuttle -command {queryServer $whoisServerName}
button .winMain.top.right.exit -bg bisque3 -text {Quit} -font "courier $buttonFontSize normal" -relief groove -cursor pirate -command exit

#.^. Create the labels, buttons and entry boxes in the top RHS

grid .winMain.top.right.domaintxt -row 0 -column 0
grid .winMain.top.right.serverName -row 1 -column 0
grid .winMain.top.right.help -row 2 -column 0 -sticky ew
grid .winMain.top.right.query -row 3 -column 0 -sticky ew

grid .winMain.top.right.domain -row 0 -column 1
grid .winMain.top.right.srvNam -row 1 -column 1
grid .winMain.top.right.about -row 2 -column 1 -sticky ew
grid .winMain.top.right.exit -row 3 -column 1 -sticky ew
#.^. Display the labels, buttons and entry boxes


text .winMain.bottom.text -width 65 -height 8 -relief sunken -borderwidth 2 -wrap none -bg #2d302a \
	-fg green -font "courier $winFontSize normal" -relief flat -wrap none \
	-cursor pencil -insertbackground green -yscrollcommand ".winMain.bottom.c set"

scrollbar .winMain.bottom.c -command ".winMain.bottom.text yview"
pack .winMain.bottom.c -side right -fill y
pack .winMain.bottom.text -side left -fill both -expand true

menu .winMain.bottom.text.m -tearoff 0
.winMain.bottom.text.m add command -label "Save" -command saveThis
.winMain.bottom.text.m add command -label "Copy" -command { event generate .winMain.bottom.text <<Copy>> }
bind .winMain.bottom.text <ButtonPress-3> {
    tk_popup .winMain.bottom.text.m %X %Y
}

proc saveThis {} {
    set types {
        {{All Files}        *             }
    }
    set filename [tk_getSaveFile -filetypes $types]

    if {$filename != ""} {
        set opnFile [open $filename w+]
        seek $opnFile 0 start
        puts $opnFile [.winMain.bottom.text get 4.0 end]
        close $opnFile
    }
}

proc writeMain {data} {
    .winMain.bottom.text insert end $data
    .winMain.bottom.text insert end "\n"
}

proc aboutThis {} {
     tk_messageBox -icon info -parent . -title "About tKWhois" -message "tKwhois \
          Domain Query Utility v0.98\n \
          1999 Raymond Edah\nc1Rcu1T mAn0r w0rk5h0p\n\nGNU General Public License v2\n\Email comments to: mudh3dz@callnetuk.com"
}

proc showHelp {} {
    global winFontSize buttonFontSize
    toplevel .wHelp
    wm title .wHelp "tKwhois Help"

    frame .wHelp.display -width 500 -height 300 -relief raised -borderwidth 2
    frame .wHelp.bottom
    pack .wHelp.display -side top -fill both -expand 1
    pack .wHelp.bottom -side bottom -fill x
#.^. Creates the frame which holds the other widgets

    text .wHelp.display.text -width 65 -height 20 -wrap none -bg bisque3 \
	-fg black -font "courier $winFontSize normal" -relief flat -wrap word \
	-cursor hand1 -insertbackground green -yscrollcommand ".wHelp.display.c set"

    scrollbar .wHelp.display.c -command ".wHelp.display.text yview"
    pack .wHelp.display.c -side right -fill y
    pack .wHelp.display.text -side left -fill both -expand true

    button .wHelp.bottom.dismiss -text close -relief flat -font "courier $buttonFontSize normal" -cursor pirate -command "destroy .wHelp"
    pack .wHelp.bottom.dismiss -side bottom

    set helpFile [open help.asc]
    while {![eof $helpFile]} {
        .wHelp.display.text insert end [read $helpFile 2048]
    }
    close $helpFile
    .wHelp.display.text configure -state disabled
}

writeMain "Ready..."


proc clearScr {} {
    .winMain.bottom.text delete 1.0 end
    writeMain "Ready..."
}

proc queryServer {serv0} {
     global domainName tbytes
     clearScr
#.^. The domain name typed in the entry box is needed here.
     set outfile [open /tmp/a.out w+]
     set whoisSock [socket -async $serv0 43]
     fconfigure $whoisSock -blocking 0 -buffering none
     update idletasks
     fileevent $whoisSock writable [writeMain "Connecting .."]
     update idletasks
     puts $whoisSock $domainName
     update idletasks
     flush $whoisSock
     update idletasks
#.^. Attempt to open conection then send query when connected.
     update idletasks
     fcopy $whoisSock $outfile -command [list showResults $whoisSock $outfile]
     update idletasks
     vwait tbytes
     update idletasks

#     set output0 [read $whoisSock]
#     fileevent $whoisSock readable [cdialog $newWin.qresult $output0]
#.^. Once there is output from the server bring up a dialog box and display result.

     update idletasks

}

proc showResults {in out size {error {}}} {
    global tbytes
    set tbytes $size
    writeMain "Read $size bytes"
    close $in
    close $out
    set dataFile [open /tmp/a.out]
    while {![eof $dataFile]} {
        .winMain.bottom.text insert end [read $dataFile 2048]
    }
    close $dataFile
}

